﻿using System;

namespace Decorator.Ejm1
{
    /// <summary>
    /// Decorador EncriyptLogger, sobreescribe el método Log. Dento del método Log, EncryptLogger 
    /// implementa una lógica simple de ciframiento alterando los caracteres una posición a la derecha,
    /// y envía a su instancia Logger el contenido para ser registrado.
    /// </summary>
    public class EncryptLogger : LoggerDecorator
    {
        public EncryptLogger(Logger inp_logger)
            : base(inp_logger)
        {

        }

        public void Log(String DataLine)
        {
            /*
             * Added functionality
             */
            DataLine = Encrypt(DataLine);
            /*
             * Now forward the encrypted text to the FileLogger for storage
             */
            logger.Log(DataLine);
        }

        public String Encrypt(String DataLine)
        {
            /*
             * Apply simple encryption by Transposition... Shift all characters by
             * one position.
             */

            DataLine = DataLine.Substring(DataLine.Length - 1)
                    + DataLine.Substring(0, DataLine.Length - 1);

            return DataLine;
        }
    }
}
