﻿using System;

namespace Decorator.Ejm1
{
    /// <summary>
    /// HTMLLogger es un decorador concreto que sobreescribe la implementación por defecto el método Log.
    /// Dentro del método Log, este decorator transforma un mensaje entrante a un documento html y 
    /// envía a su instancia logger su contenido para ser registrado.
    /// </summary>
    public class HTMLLogger : LoggerDecorator
    {
        public HTMLLogger(Logger inp_logger)
            : base(inp_logger)
        {

        }

        public void Log(String DataLine)
        {
            /*
             * Added functionality
             */
            DataLine = MakeHTML(DataLine);
            /*
             * Now forward the encrypted text to the FileLogger for storage
             */
            logger.Log(DataLine);
        }

        public String MakeHTML(String DataLine)
        {
            /*
             * Make it into an HTML document.
             */
            DataLine = "<HTML><BODY>" + "<b>" + DataLine + "</b>"
                    + "</BODY></HTML>";
            return DataLine;
        }
    }
}
