﻿using System;

namespace Decorator.Ejm1
{
    /// <summary>
    /// Es el decorador. El LoggerDecorator implementa la interfaz Logger y provee la implementación 
    /// por defecto básica para el método Log, donde se redirecciona la llamada al objeto Logger 
    /// envuelto. 
    /// </summary>
    public class LoggerDecorator : Logger
    {
        protected Logger logger;

        public LoggerDecorator(Logger inp_logger)
        {
            logger = inp_logger;
        }

        public void Log(String DataLine)
        {
            /*
             * Default implementation to be overriden by subclasses.
             */
            logger.Log(DataLine);
        }
    }
}
